import { metrics as m } from '@nodeswork/utils';
import * as sMongoose from '../mongoose';
export declare type MetricsModelType = typeof MetricsModel & sMongoose.ModelType;
export declare class MetricsModel extends sMongoose.Model implements m.MetricsData {
    timerange: {
        start: number;
        end: number;
    };
    dimensions: m.Dimensions;
    metrics: m.Metrics;
    appendMetrics(options: m.UpdateMetricsDataOptions<any>): void;
    static appendMetrics(options: SetMetricsOptions): Promise<MetricsModel>;
    static createMetrics<T extends MetricsModel>(options: CreateMetricsOptions): Promise<T>;
    static searchMetrics<T extends MetricsModel>(options: MetricsSearchOptions): Promise<T[]>;
    static aggregateMetrics(options: AggregateMetricsOptions): Promise<m.MetricsData[]>;
}
export interface CreateMetricsOptions {
    ts?: number;
    metrics?: Array<m.UpdateMetricsDataOptions<any>>;
    doc?: object;
}
export interface MetricsSearchOptions {
    timerange: {
        start: number;
        end: number;
    };
    query?: object;
    project?: object;
    queryOptions?: object;
    dimensions?: string | string[];
    metrics?: string | string[];
}
export interface AggregateMetricsOptions extends MetricsSearchOptions {
    ids?: boolean;
    granularityInSecond: number;
}
export interface SetMetricsOptions extends m.UpdateMetricsDataOptions<any> {
    id: string;
}
